<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 10</a>

    <script>
    
        let M = 8,
            N = 8;

        const rellenoPinturaUtil = (pantalla, x, y, antC, nuevC) => { 

            if (x < 0 || x >= M || y < 0 || y >= N) {
                return;
            }            

            if (pantalla[x][y] != antC) {
                return;
            }
            
            pantalla[x][y] = nuevC;

            rellenoPinturaUtil(pantalla, x + 1, y, antC, nuevC);
            rellenoPinturaUtil(pantalla, x - 1, y, antC, nuevC);
            rellenoPinturaUtil(pantalla, x, y + 1, antC, nuevC);
            rellenoPinturaUtil(pantalla, x, y - 1, antC, nuevC);
        }

        const rellenoPintura = (pantalla, x, y, nuevC) => {
            let antC = pantalla[x][y];
            if (antC === nuevC) {
                return;
            }
            rellenoPinturaUtil(pantalla, x, y, antC, nuevC);
        }       
 
        let pantalla = [
            [1, 1, 1, 1, 1, 1, 1, 1],
            [1, 1, 1, 1, 1, 1, 0, 0],
            [1, 0, 0, 1, 1, 0, 1, 1],
            [1, 2, 2, 2, 2, 0, 1, 0],
            [1, 1, 1, 2, 2, 0, 1, 0],
            [1, 1, 1, 2, 2, 2, 2, 0],
            [1, 1, 1, 1, 1, 2, 1, 1],
            [1, 1, 1, 1, 1, 2, 2, 1],
        ],
        x = 4,
        y = 4,
        nuevC = 4;

        document.write("<br>");
        document.write("Pantalla dada: <br>");
        for (var i = 0; i < M; i++) {
            for (var j = 0; j < N; j++) {
                document.write(pantalla[i][j] + " ");
            }
            document.write("<br>");
        }

        rellenoPintura(pantalla, x, y, nuevC);
        
        document.write("<br>");
        document.write("Pantalla actualizada por el nuevo color: <br>");
        for (var i = 0; i < M; i++) {
            for (var j = 0; j < N; j++) {
                document.write(pantalla[i][j] + " ");
            }
            document.write("<br>");
        }
        
        
</script>
    
</body>
</html>